import {
    Block,
    Form,
    FormFieldWrapper,
    Input,
    Popup,
    PopupContent,
    PopupFooter,
    PopupHeader,
} from '@ensi-platform/core-components';
import { useCallback, useMemo, useState } from 'react';
import * as Yup from 'yup';

import {
    OMSSettings,
    useBasketSettingsMeta,
    useBasketsSettings,
    useOmsSettings,
    useOmsSettingsMeta,
    useUpdateBasketsSettings,
    useUpdateOMSSettings,
} from '@api/orders';

import { useError, useSuccess } from '@context/modal';

import PageWrapper from '@components/PageWrapper';
import Table, { ExtendedRow, TooltipItem, useSorting, useTable } from '@components/Table';
import { getSettingsColumn } from '@components/Table/columns';
import { TableHeader } from '@components/Table/components';

import { ErrorMessages, ModalMessages } from '@scripts/constants';
import { Button, scale, typography } from '@scripts/gds';
import { declOfNum } from '@scripts/helpers';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

import useSettingsAccess from './useSettingsAccess';

export default function OrdersSettings() {
    const [isOpen, setIsOpen] = useState(false);
    const [activeRow, setActiveRow] = useState<OMSSettings | null>(null);
    const [activeTable, setActiveTable] = useState<'settings' | 'basket' | null>(null);

    const {
        canViewListingAndFilters,
        canEditPropertyCart,
        canEditOrderPaymentTime,
        canEditOrderRegistrationTime,
        canEditProcessingTime,
    } = useSettingsAccess();

    const closePopup = useCallback(() => {
        setIsOpen(false);
        setActiveTable(null);
        // чтобы не портить анимацию
        setTimeout(() => setActiveRow(null), 300);
    }, []);

    const { data: omsData, error: omsError } = useOmsSettings(canViewListingAndFilters);
    const { data: basketsData, error: basketsError } = useBasketsSettings(canViewListingAndFilters);

    const { data: basketSettingsMetaData, error: basketSettingsMetaError } =
        useBasketSettingsMeta(canViewListingAndFilters);
    const basketSettingsMeta = basketSettingsMetaData?.data;

    const { metaField: basketSettingsMetaField } = useAutoFilters(basketSettingsMeta);

    const basketSettings = useAutoTableData<OMSSettings>(basketsData?.data, basketSettingsMetaField);
    const basketSettingsAutoGeneratedColumns = useAutoColumns(basketSettingsMeta, false);

    const { data: omsSettingsMetaData, error: omsSettingsMetaError } = useOmsSettingsMeta(canViewListingAndFilters);
    const omsSettingsMeta = omsSettingsMetaData?.data;

    const { metaField: omsSettingsMetaField } = useAutoFilters(omsSettingsMeta);

    const omsSettings = useAutoTableData<OMSSettings>(omsData?.data, omsSettingsMetaField);
    const omsSettingsAutoGeneratedColumns = useAutoColumns(omsSettingsMeta, false);

    const canEdit = useCallback(
        (code: string) => {
            switch (code) {
                case 'timeForPayment':
                    return canEditOrderPaymentTime;
                case 'timeForRefund':
                    return canEditOrderRegistrationTime;
                case 'maxTimeOrderProcessing':
                    return canEditProcessingTime;
                default:
                    return false;
            }
        },
        [canEditOrderPaymentTime, canEditOrderRegistrationTime, canEditProcessingTime]
    );

    const updateSettings = useUpdateOMSSettings();
    const updateBasketSettings = useUpdateBasketsSettings();

    useError(omsError);
    useError(basketsError);
    useError(updateSettings.error);
    useError(updateBasketSettings.error);
    useError(basketSettingsMetaError);
    useError(omsSettingsMetaError);

    useSuccess(updateSettings.status === 'success' ? ModalMessages.SUCCESS_UPDATE : '');
    useSuccess(updateBasketSettings.status === 'success' ? ModalMessages.SUCCESS_UPDATE : '');

    const editRowSettings = useCallback((row: ExtendedRow['original'][] | undefined) => {
        if (row) {
            setActiveRow(row[0].original as OMSSettings);
            setIsOpen(true);
            setActiveTable('settings');
        }
    }, []);
    const tooltipContentSettings: TooltipItem[] = useMemo(
        () => [
            {
                type: 'edit',
                text: 'Редактировать параметр',
                action: editRowSettings,
                isDisable: (row: ExtendedRow['original'][] | undefined) => {
                    if (row) return !canEdit(row[0].original.code);
                },
            },
        ],
        [editRowSettings, canEdit]
    );
    const omsSettingsColumns = useMemo(
        () => [
            ...omsSettingsAutoGeneratedColumns,
            getSettingsColumn({
                columnsToDisable: [],
                visibleColumns: omsSettingsMeta?.default_list,
                tooltipContent: tooltipContentSettings,
            }),
        ],
        [omsSettingsAutoGeneratedColumns, omsSettingsMeta?.default_list]
    );

    const editRowBasket = useCallback((row: ExtendedRow['original'][] | undefined) => {
        if (row) {
            setActiveRow(row[0].original as OMSSettings);
            setIsOpen(true);
            setActiveTable('basket');
        }
    }, []);
    const tooltipContentBasket: TooltipItem[] = useMemo(
        () => [
            {
                type: 'edit',
                text: 'Редактировать параметр',
                action: editRowBasket,
                isDisable: !canEditPropertyCart,
            },
        ],
        [canEditPropertyCart, editRowBasket]
    );
    const basketSettingsColumns = useMemo(
        () => [
            ...basketSettingsAutoGeneratedColumns,
            getSettingsColumn({
                columnsToDisable: [],
                visibleColumns: basketSettingsMeta?.default_list,
                tooltipContent: tooltipContentBasket,
            }),
        ],
        [basketSettingsAutoGeneratedColumns, basketSettingsMeta?.default_list]
    );

    const initialValues = useMemo(
        () => ({
            id: activeRow?.id || '',
            name: activeRow?.name || '',
            value: activeRow?.value || '',
        }),
        [activeRow]
    );

    const [{ sorting }, sortingPlugin] = useSorting<OMSSettings>('oms-settings', [], undefined, false);

    const omsTable = useTable(
        {
            data: omsSettings,
            columns: omsSettingsColumns,
            meta: {
                tableKey: `oms-settings`,
            },
            state: {
                sorting,
            },
        },
        [sortingPlugin]
    );

    const [{ sorting: basketSorting }, basketSortingPlugin] = useSorting<OMSSettings>(
        'basket-settings',
        [],
        undefined,
        false
    );

    const basketTable = useTable(
        {
            data: basketSettings,
            columns: basketSettingsColumns,
            meta: {
                tableKey: `basket-settings`,
            },
            state: {
                sorting: basketSorting,
            },
        },
        [basketSortingPlugin]
    );

    return (
        <PageWrapper h1={canViewListingAndFilters ? 'Настройка oms' : ''}>
            {canViewListingAndFilters ? (
                <>
                    <h2 css={{ ...typography('h2'), marginBottom: scale(2) }}>Общие параметры</h2>
                    <Block>
                        <Block.Body>
                            <TableHeader css={{ justifyContent: 'space-between' }}>
                                <p>
                                    Всего{' '}
                                    {`${omsSettings?.length} ${declOfNum(omsSettings?.length || 0, [
                                        'параметр',
                                        'параметра',
                                        'параметров',
                                    ])}`}
                                </p>
                            </TableHeader>
                            <Table instance={omsTable} />
                        </Block.Body>
                    </Block>
                    <h2 css={{ ...typography('h2'), marginTop: scale(2), marginBottom: scale(2) }}>
                        Параметры корзины
                    </h2>
                    <Block>
                        <Block.Body>
                            <TableHeader css={{ justifyContent: 'space-between' }}>
                                <p>
                                    Всего{' '}
                                    {`${basketSettings?.length} ${declOfNum(basketSettings?.length || 0, [
                                        'параметр',
                                        'параметра',
                                        'параметров',
                                    ])}`}
                                </p>
                            </TableHeader>
                            <Table instance={basketTable} />
                        </Block.Body>
                    </Block>
                    <Popup onClose={closePopup} open={isOpen}>
                        <PopupHeader title="Редактирование параметра" />
                        <Form
                            initialValues={initialValues}
                            validationSchema={Yup.object().shape({
                                name: Yup.string().required(ErrorMessages.REQUIRED),
                                value: Yup.string().required(ErrorMessages.REQUIRED),
                            })}
                            onSubmit={({ id, name, value }) => {
                                const newData = {
                                    id,
                                    name,
                                    value,
                                };

                                if (activeTable === 'settings') {
                                    updateSettings.mutate([newData]);
                                }

                                if (activeTable === 'basket') {
                                    updateBasketSettings.mutate([newData]);
                                }

                                closePopup();
                            }}
                        >
                            <PopupContent>
                                <FormFieldWrapper name="name" label="Название" css={{ marginBottom: scale(2) }}>
                                    <Input />
                                </FormFieldWrapper>
                                <FormFieldWrapper name="value" label="Значение" css={{ marginBottom: scale(2) }}>
                                    <Input />
                                </FormFieldWrapper>
                            </PopupContent>
                            <PopupFooter>
                                <Button theme="secondary" onClick={closePopup}>
                                    Отмена
                                </Button>
                                <Button type="submit">Сохранить</Button>
                            </PopupFooter>
                        </Form>
                    </Popup>
                </>
            ) : (
                <h1 css={{ ...typography('h1'), textAlign: 'center' }}>
                    У вас недостаточно прав для просмотра настроек
                </h1>
            )}
        </PageWrapper>
    );
}
